#pragma once

#include "gui.h"
#include "framebuffer.h"
#include "ppc.h"
#include "tmesh.h"

class Scene {
public:
  PPC *ppc, toVis;
  TMesh *tms;
  int tmsN;
  GUI *gui;
  FrameBuffer *fb;
  Scene();
  void DBG();
  void Render();
  void FrameSetup();
  void SaveView0();
  void LoadView0();
  void GoToView0();
  void SaveView1();
  void LoadView1();
  void GoToView1();
  void GoToView(PPC *nppc);
};

extern Scene *scene;


#if 0
void Render(FrameBuffer *fb, PPC *ppc) {

  for (int tmi = 0; tmi < tmsN; tmi++) {
    tms[tmi]->Project(ppc);
    for (int tri = 0; tri < tms[tmi]->trisN; tri++) {
      // Rasterization setup
        // setup edge equations
        // setup linear expression coefficients for rasterization parameter interpolation
        // rasterization parameters: R, G, B, "z", nx, ny, nz
        // (Ar, Br, Cr) ...

      // Compute AABB for triangle
      // Clip AABB

      for (v = top to down) {
        for (u = left to right) {
          // inner most loop of the rendering function
          // current pixel is (u, v); pixv(u, v, 1)
          if ((u, v) is outside triangle)
            continue; // pixel is in AABB but not in triangle projection
          float currz = Az * u + Bz * v + Cz; // ABCz*pixv
          if (currz farther than what's already in zbuffer at (u, v))
            continue; // current triangle not visible at current pixel; hidden by previously rendered triangle
          // compute color
          // option 1: interpolate vertex color for current pixel (Gouraud shading)
          // option 2: compute lighting expression at current pixel and modify input color
          // option 3: find current texture coordinates (s, t), look up texture at (s, t)
          fb->Set(u, v, computePixelColor);
        }
      }

    }
  }

}
#endif
